Bug 8372 - [3.2/3.3 regression] ICE on explicit call of destructor
[3.2/3.3 regression] ICE on explicit call of destructor
Status: RESOLVED FIXED
Product: gcc
Classification: Unclassified
Component: c++
3.2
: P3 normal
: ---
Assigned To: Mark Mitchell
: ice-on-valid-code
: 8476 (view as bug list)
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2002-10-27 15:56 UTC by Volker Reichelt
Modified: 2003-07-25 17:33 UTC (History)
2 users (show)

See Also:
Host:
Target:
Build:
Known to work:
Known to fail:
Last reconfirmed:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Volker Reichelt 2002-10-27 15:56:00 UTC
The following code causes an ICE when compiled with "g++ -c"

--------------------snip here-----------------
struct A {};

template <typename T> struct B
{
  B() { A().A::~A(); }
};

B<void> b;
--------------------snip here-----------------

Release:
gcc 3.0.x, 3.2 branch and mainline

Environment:
i686-pc-linux-gnu
Comment 1 Volker Reichelt 2002-10-27 15:56:00 UTC
Fix:
http://gcc.gnu.org/ml/gcc-patches/2002-12/msg00590.html
Comment 2 Volker Reichelt 2002-10-27 15:58:44 UTC
State-Changed-From-To: open->analyzed
State-Changed-Why: It's a regression from 2.95.x.
Comment 3 Mark Mitchell 2002-12-10 14:15:41 UTC
Responsible-Changed-From-To: unassigned->mmitchel
Responsible-Changed-Why: Working on a fix.
Comment 4 Mark Mitchell 2002-12-10 14:34:15 UTC
State-Changed-From-To: analyzed->closed
State-Changed-Why: Fixed in GCC 3.2.2, GCC 3.3.
Comment 5 Mark Mitchell 2002-12-10 22:31:41 UTC
From: mmitchel@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: c++/8372
Date: 10 Dec 2002 22:31:41 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Changes by:	mmitchel@gcc.gnu.org	2002-12-10 14:31:40
 
 Modified files:
 	gcc/cp         : ChangeLog pt.c 
 	gcc/testsuite  : ChangeLog 
 Added files:
 	gcc/testsuite/g++.dg/template: dtor1.C 
 
 Log message:
 	PR c++/8372
 	* pt.c (tsubst_copy): Handle destructor names more correctly.
 	
 	PR c++/8372
 	* g++.dg/template/dtor1.C: New test.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&r1=1.3073&r2=1.3074
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/pt.c.diff?cvsroot=gcc&r1=1.634&r2=1.635
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&r1=1.2257&r2=1.2258
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/template/dtor1.C.diff?cvsroot=gcc&r1=NONE&r2=1.1
 

Comment 6 Mark Mitchell 2002-12-10 22:31:41 UTC
From: mmitchel@gcc.gnu.org
To: gcc-gnats@gcc.gnu.org
Cc:  
Subject: c++/8372
Date: 10 Dec 2002 22:31:41 -0000

 CVSROOT:	/cvs/gcc
 Module name:	gcc
 Changes by:	mmitchel@gcc.gnu.org	2002-12-10 14:31:40
 
 Modified files:
 	gcc/cp         : ChangeLog pt.c 
 	gcc/testsuite  : ChangeLog 
 Added files:
 	gcc/testsuite/g++.dg/template: dtor1.C 
 
 Log message:
 	PR c++/8372
 	* pt.c (tsubst_copy): Handle destructor names more correctly.
 	
 	PR c++/8372
 	* g++.dg/template/dtor1.C: New test.
 
 Patches:
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&r1=1.3073&r2=1.3074
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/pt.c.diff?cvsroot=gcc&r1=1.634&r2=1.635
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&r1=1.2257&r2=1.2258
 http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/template/dtor1.C.diff?cvsroot=gcc&r1=NONE&r2=1.1